unit DBISAMUserControl;

interface

uses
{$IFDEF Ver130}
{$ELSE}
  Variants,
{$ENDIF}
  SysUtils, Classes, UCDefine, UCConsts, UCMessages, DB, Dialogs,
  Menus, ActnList, Controls, DBISAMTb;

type
  TDBISAMUserControl = class(TUCDefine)
  private
    FDatabase: TDBISAMDatabase;
    FSession: TDBISAMSession;
    procedure actBtPassClick(Sender: TObject);
    procedure actIncPermiss(idUser: Integer; Modulo, ObjName: String);
    procedure btexcluiClick(Sender: TObject);
    procedure BtExcluiUserClick(Sender: TObject);
    procedure btfiltroClick(Sender: TObject);
    procedure BtGravaPermissClick(Sender: TObject);
    procedure BtGravaPermissPerfilClick(Sender: TObject);
    procedure btGravarUsuarioClick(Sender: TObject);
    procedure btIncPerGravarClick(Sender: TObject);
    procedure BtPerAltClick(Sender: TObject);
    procedure BtPerExcluiClick(Sender: TObject);
    procedure btPerfAdicClick(Sender: TObject);
    procedure btUserAdicClick(Sender: TObject);
    procedure BtUserAltClick(Sender: TObject);
    function GetNewIdUser: Integer;
    procedure LogFormShow(Sender: TObject);
    function DBIGetQuery : TDBISAMQuery;
    procedure SetFDatabase(const Value: TDBISAMDatabase);
    procedure SetFSession(const Value: TDBISAMSession);

  protected
    procedure CriaCadUserForm;override;
    procedure CriaProfileUserForm;override;
    procedure ActionLog(Sender : TObject); override;
    procedure ActionBtPermiss(Sender : TObject);override;
    procedure ActionBtPermissProfile(Sender: TObject);override;
    procedure Notification(AComponent: TComponent; Operation: TOperation);override;
    procedure UCExecSQL(FSQL: String);override;
    function UCGetSQLDataset(FSQL : String) : TDataset;override;
    function UCFindTable(const Tablename : String) : Boolean; override;
    function UCFindDataConnection : Boolean; override;
  public
    property CurrentUser;
  published
    property Database : TDBISAMDatabase read FDatabase write SetFDatabase;
    property Session : TDBISAMSession read FSession write SetFSession;
  end;



procedure Register;

implementation

uses UserPermis_U, CadUser_U, CadPerfil_U, TrocaSenha_U, LoginWindow_U,
  ViewLog_U, IncUser_U, IncPerfil_U;

{ TDBISAMUserControl }

procedure TDBISAMUserControl.SetFDatabase(const Value: TDBISAMDatabase);
begin
  FDatabase := Value;
  if Value <> nil then Value.FreeNotification(Self);
end;

procedure TDBISAMUserControl.SetFSession(const Value: TDBISAMSession);
begin
  FSession := Value;
  if Value <> nil then Value.FreeNotification(Self);
end;

function TDBISAMUserControl.DBIGetQuery : TDBISAMQuery;
begin
  Result := TDBISAMQuery.Create(nil);
  Result.SessionName := FDatabase.SessionName;
  Result.DatabaseName := FDatabase.RemoteDatabase;
//FDatabase.SessionName := 'Traficos';
  {if FSession.SessionType = stLocal then begin}
  {if FDatabase.Session.SessionType = stLocal then begin
  Result.DatabaseName := FDatabase.DatabaseName;
  end;}
  {if FDatabase.Session.SessionType = stRemote then begin
  Result.DatabaseName := FDatabase.RemoteDatabase;
  end;}
end;


procedure TDBISAMUserControl.ActionBtPermiss(Sender: TObject);
begin
  inherited;
  UserPermis.TempIdUser := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IdUser').asInteger;

  UserPermis.DSPermiss := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IdUser').asString + ' and Modulo = ' + QuotedStr(ApplicationID));
  UserPermis.DSPermiss.Open;

  UserPermis.DSCmd := DBIGetQuery;

  UserPermis.DSPerfil := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + IntToStr(TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Perfil').asInteger) + ' and Modulo = ' + QuotedStr(ApplicationID));
  UserPermis.DSPerfil.Open;
  UserPermis.BtGrava.OnClick := BtGravaPermissClick;

  UserPermis.ShowModal;
  FreeAndNil(UserPermis);
end;

procedure TDBISAMUserControl.ActionBtPermissProfile(Sender: TObject);
begin
  inherited;
  UserPermis.TempIdUser := TCadPerfil(FormPerfilUsuarios).DSPerfilUser.FieldByName('IdUser').asInteger;

  UserPermis.DSPermiss := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + TCadPerfil(FormPerfilUsuarios).DSPerfilUser.FieldByName('IdUser').asString + ' and Modulo = ' + QuotedStr(ApplicationID));
  UserPermis.DSPermiss.Open;

  UserPermis.DSCmd := DBIGetQuery;

  UserPermis.DSPerfil := TDataset.Create(nil);

  UserPermis.BtGrava.OnClick := BtGravaPermissPerfilClick;

  UserPermis.ShowModal;
  FreeAndNil(UserPermis);
end;

procedure TDBISAMUserControl.CriaCadUserForm;
begin
  inherited;
  with TCadUser(FormCadastroUsuarios) do
  begin
    DSCadUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios+ ' Where Tipo = '+QuotedStr('U')+' ORDER BY Login');
    DSCadUser.Open;
    DBGrid1.Columns[0].Title.Caption := Settings.UsersForm.ColName;
    DBGrid1.Columns[1].Title.Caption := Settings.UsersForm.ColLogin;
    DBGrid1.Columns[2].Title.Caption := Settings.UsersForm.ColEmail;

    DScmd := DBIGetQuery;

    DSNewId := TDataset.Create(nil);

    DSPerfilUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios+ ' Where Tipo = '+QuotedStr('P')+' ORDER BY Nome');
    DSPerfilUser.Open;
    //desvia procedures dos eventos dos botoes
    btAdic.OnClick := btUserAdicClick;
    BtAlt.OnClick := BtUserAltClick;
    BtExclui.OnClick := BtExcluiUserClick;
    BtPass.OnClick := actBtPassClick;
  end;
end;

procedure TDBISAMUserControl.CriaProfileUserForm;
begin
  inherited;
  with TCadPerfil(FormPerfilUsuarios) do
  begin
    DSPerfilUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios +' Where Tipo = '+QuotedStr('P'));
    DSPerfilUser.Open;
    DBGrid1.Columns[0].Title.Caption := Settings.UsersProfile.ColProfile;

    DSCmd := DBIGetQuery;
    //desvia procedures dos eventos dos botoes
    btAdic.OnClick := btPerfAdicClick;
    BtAlt.OnClick := BtPerAltClick;
    BtExclui.OnClick := BtPerExcluiClick;
  end;
end;

procedure Register;
begin
  RegisterComponents('User Control', [TDBISAMUserControl]);
end;


procedure TDBISAMUserControl.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  if (Operation = opRemove) and (AComponent = FDatabase) then FDatabase := nil;
  if (Operation = opRemove) and (AComponent = FSession) then FSession := nil;
  inherited Notification(AComponent, Operation);
end;

procedure TDBISAMUserControl.ActionLog(Sender: TObject);
begin
  inherited;
  TViewLog(FormLogControl).OnShow := LogFormShow;
  TViewLog(FormLogControl).btexclui.OnClick := btexcluiClick;
  TViewLog(FormLogControl).btfiltro.OnClick := btfiltroClick;
  TViewLog(FormLogControl).DSLog := DBIGetQuery;
  TViewLog(FormLogControl).DSCmd :=DBIGetQuery;

  TViewLog(FormLogControl).ShowModal;
  FreeAndNil(FormLogControl);
end;


procedure TDBISAMUserControl.UCExecSQL(FSQL: String);
begin
  with DBIGetQuery do
  begin
    SQL.Text := FSQL;
    ExecSQL;
    Free;
  end;
end;


function TDBISAMUserControl.UCGetSQLDataset(FSQL: String): TDataset;
begin
  Result := DBIGetQuery;

  with Result as TDBISAMQuery do
  begin
    SQL.text := FSQL;
    Open;
  end;
end;

function TDBISAMUserControl.UCFindTable(const TableName: String): Boolean;
var
  Lista : TStringList;
begin
  Lista := TStringList.Create;
  FDatabase.Session.GetTableNames(FDatabase.RemoteDatabase,Lista);
  Result := Lista.IndexOf(TableName) > -1;
  FreeAndNil(Lista);
end;

function TDBISAMUserControl.UCFindDataConnection: Boolean;
begin
    Result := (Assigned(FDatabase)) and Assigned((FSession));
end;



// Procedures desviadadas por motivos de imcompatibilidade entre IProviderSupport e ZeosDBO
  //rotinas do cadastro de usuarios
  function TDBISAMUserControl.GetNewIdUser: Integer;
  var
    Temp : Integer;
  begin
    with DBIGetQuery do begin
      SQL.Text := 'Select Max(IdUser) as IdUser from '+ TableUsers;
      Open;
      Temp := Fieldbyname('idUser').asInteger+1;
      Close;
      Free;
    end;
    if Temp = 0 then Result := 1 else Result := Temp;
  end;

  procedure TDBISAMUserControl.btUserAdicClick(Sender: TObject);
  begin
    IncUser := TIncUser.Create(TCadUser(FormCadastroUsuarios));
    TCadUser(FormCadastroUsuarios).SetWindow(True);
    IncUser.btGravar.OnClick := btGravarUsuarioClick;
    IncUser.ShowModal;
    FreeAndNil(IncUser);
  end;

  procedure TDBISAMUserControl.BtUserAltClick(Sender: TObject);
  begin
    if TCadUser(FormCadastroUsuarios).DSCadUser.RecordCount = 0 then Exit;
    IncUser := TIncUser.Create(TCadUser(FormCadastroUsuarios));
    IncUser.btGravar.OnClick := btGravarUsuarioClick;
    TCadUser(FormCadastroUsuarios).SetWindow(False);
    With IncUser do begin
      FAltera := True;
      EditNome.Text := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Nome').asString;
      EditLogin.Text := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Login').asString;
      EditEmail.Text := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Email').asString;
      ComboPerfil.KeyValue := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Perfil').asInteger;
      ckPrivilegiado.Checked := StrToBool(TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Privilegiado').asString);
      ShowModal;
    end;
    FreeAndNil(IncUser);
  end;

  procedure TDBISAMUserControl.BtExcluiUserClick(Sender: TObject);
  var
    TempID : Integer;
    CanDelete : Boolean;
    ErrorMsg : String;
  begin
    if TCadUser(FormCadastroUsuarios).DSCadUser.RecordCount = 0 then Exit;
    TempID := TCadUser(FormCadastroUsuarios).DSCadUser.fieldByName('IDUser').asInteger;
    if MessageDlg(Format(Settings.UsersForm.PromptDelete, [TCadUser(FormCadastroUsuarios).DSCadUser.fieldByName('Nome').asString]), mtConfirmation, [mbYes,mbNo], 0) = mrYes then
    begin
      CanDelete := True;
      if Assigned(onDeleteUser) then onDeleteUser(TObject(Owner),TempID, CanDelete, ErrorMsg);
      if Not CanDelete then begin
        MessageDlg(ErrorMSG, mtWarning, [mbOK], 0);
        Exit;
      end;
      UCExecSql('Delete from '+ TableUsers + ' where IDUser = '+ IntToStr(TempID));
      UCExecSql('Delete from '+ TableRights + ' where IDUser = '+ IntToStr(TempID));
      TCadUser(FormCadastroUsuarios).DSCadUser.Close;
      TCadUser(FormCadastroUsuarios).DSCadUser.Open;
      TCadUser(FormCadastroUsuarios).DSCadUser.First;

    end;
  end;

  procedure TDBISAMUserControl.actBtPassClick(Sender: TObject);
  var
    FNovasenha : String;
  begin
    if TCadUser(FormCadastroUsuarios).DSCadUser.RecordCount = 0 then Exit;
    if Inputquery(Format( Settings.ChangePassword.WindowCaption,[TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Login').asString]), Settings.ChangePassword.LabelNewPassword ,FNovaSenha) then
    begin
  {$IFDEF VER130}
  {$ELSE}
      if (Assigned(MailUserControl)) and (MailUserControl.SenhaForcada.Ativo ) then
        try
          with TCadUser(FormCadastroUsuarios).DSCadUser do
            MailUserControl.EnviaEmailSenhaForcada(
                                             fieldbyname('nome').asString ,
                                             fieldbyname('login').asString,
                                             Encrypt(FNovasenha, EncryptKey),
                                             fieldbyname('email').asString,
                                             '');
        except
          on E : Exception do Log(e.Message,2);
        end;
  {$ENDIF}
      UCExecSql('UPDATE ' + TableUsers + ' Set Senha = '+ QuotedStr(Encrypt(FNovasenha, EncryptKey)) + ' Where IDUser = ' + TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IDUser').asString);
    end;
  end;

  procedure TDBISAMUserControl.btGravarUsuarioClick(Sender: TObject);
  var
    FNovasenha, FNome, FLogin, FEmail  : String;
    FNewIdUser, FPerfil : integer;
    FPriv : Boolean;
  begin
    IncUser.btGravar.Enabled := False;

    if not IncUser.FAltera then
    begin // inclui user
      FNovasenha := LowerCase(Copy(Encrypt(FormatDateTime('zzzmm',Now),EncryptKey),2,6));
      if not Inputquery(Format(Settings.ResetPassword.WindowCaption,[IncUser.EditLogin.Text]), Settings.ResetPassword.LabelPassword, FNovaSenha) then
      begin
        MessageDlg(Settings.CommonMessages.BlankPassword, mtWarning, [mbOK], 0);
        FNovasenha := '';
      end;
      FNewIdUser := GetNewIdUser;
      FNome := IncUser.EditNome.Text;
      FLogin := IncUser.EditLogin.Text;
      FEmail := IncUser.EditEmail.Text;
      if IncUser.ComboPerfil.KeyValue = null then FPerfil := 0 else FPerfil := IncUser.ComboPerfil.KeyValue;
      FPriv := IncUser.ckPrivilegiado.Checked;

      if Assigned( OnAddUser) then OnAddUser(Self, FLogin, FNovaSenha, FNome, FEmail, FPerfil, FPriv);

      UCExecSQL( 'INSERT INTO ' + TableUsers +
                 ' ( IdUser, Nome, Login, Email, Privilegiado, Senha, Tipo, Perfil ) '+
                 ' Values ( '+
                 IntToStr(FNewIdUser) +', '+
                 QuotedStr(FNome) + ', '+
                 QuotedStr(FLogin) + ', '+
                 QuotedStr(FEmail) + ', '+
                 BooltoStr(FPriv)+', '+
                 QuotedStr(Encrypt(FNovaSenha, EncryptKey))+', '+
                 QuotedStr('U')+', '+
                 IntToStr(FPerfil)+')');
      {$IFDEF Ver130}
      {$ELSE}
      if (Assigned(MailUserControl)) and (MailUserControl.AdicionaUsuario.Ativo ) then
        try
          MailUserControl.EnviaEmailAdicionaUsuario(FNome, FLogin, Encrypt(FNovaSenha, EncryptKey) , FEmail, IntToStr(FPerfil), EncryptKey);
        except
          on E : Exception do Log(e.Message,2);
        end;
      {$ENDIF}
    end else begin // alterar user
      FNewIdUser := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IdUser').asInteger;
      FNome := IncUser.EditNome.Text;
      FLogin := IncUser.EditLogin.Text;
      FEmail := IncUser.EditEmail.Text;
      if IncUser.ComboPerfil.KeyValue = null then FPerfil := 0 else FPerfil := IncUser.ComboPerfil.KeyValue;
      FPriv := IncUser.ckPrivilegiado.Checked;

      if Assigned( OnChangeUser) then
        OnChangeUser(Self,FNewIdUser, FLogin, FNome, FEmail, FPerfil, FPriv);


      UCExecSQL('UPDATE '+ TableUsers + ' SET '+
                'Nome = '+ QuotedStr(FNome) + ', '+
                'Login = '+ QuotedStr(FLogin) + ', '+
                'Email = '+ QuotedStr(FEmail) +', '+
                'Privilegiado = '+ BooltoStr(FPriv)+', '+
                'Perfil = '+ IntToStr(FPerfil)+
                ' Where IdUser = ' + IntToStr(FNewIdUser));

      {$IFDEF Ver130}
      {$ELSE}
      if (Assigned(MailUserControl)) and (MailUserControl.AlteraUsuario.Ativo ) then
        try
          MailUserControl.EnviaEmailAlteraUsuario(FNome, FLogin, TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('senha').asString, FEmail, IntToStr(FPerfil), EncryptKey);
        except
          on E : Exception do Log(e.Message,2);
        end;
      {$ENDIF}
    end;
    TCadUser(FormCadastroUsuarios).DSPerfilUser.Close;
    TCadUser(FormCadastroUsuarios).DSPerfilUser.Open;
    TCadUser(FormCadastroUsuarios).DSCadUser.Close;
    TCadUser(FormCadastroUsuarios).DSCadUser.Open;
    TCadUser(FormCadastroUsuarios).DSCadUser.Locate('IDUser',FNewIdUser,[]);
    IncUser.Close;
  end;

  //bt gravar permissoes do usuario
  procedure TDBISAMUserControl.actIncPermiss( idUser : Integer; Modulo, ObjName : String);
  begin
    UCExecSQL('INSERT INTO '+ TableRights +
                         '( IdUser, Modulo, ObjName) Values ( '+
                         IntToStr(IdUser) + ', '+
                         QuotedStr(Modulo) + ', '+
                         QuotedStr(ObjName)  +')');
  end;

  procedure TDBISAMUserControl.BtGravaPermissClick(Sender: TObject);
  var
    Contador,TempIdUser : Integer;
  begin

    TempIdUser := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IdUser').asInteger;
    UCExecSQL('Delete from '+ TableRights + ' Where IdUser = '+ IntToStr(TempIdUser) + ' and Modulo = '+ QuotedStr(ApplicationID));

    For Contador := 0 to UserPermis.TreeMenu.Items.Count -1 do
      if PTreeMenu(UserPermis.TreeMenu.Items[Contador].Data).Selecionado = 1 then
        actIncPermiss(TempIdUser, ApplicationID, PTreeMenu(UserPermis.TreeMenu.Items[Contador].Data).MenuName);

    For Contador := 0 to UserPermis.TreeAction.Items.Count -1 do
      if PTreeAction(UserPermis.TreeAction.Items[Contador].Data).Selecionado = 1 then
        actIncPermiss( TempIdUser, ApplicationID, PTreeAction(UserPermis.TreeAction.Items[Contador].Data).MenuName);
    UserPermis.Close;
  end;


  procedure TDBISAMUserControl.BtGravaPermissPerfilClick(Sender: TObject);
  var
    Contador,TempIdUser : Integer;
  begin

    TempIdUser := TCadPerfil(FormPerfilUsuarios).DsPerfilUser.FieldByName('IdUser').asInteger;
    UCExecSQL('Delete from '+ TableRights + ' Where IdUser = '+ IntToStr(TempIdUser) + ' and Modulo = '+ QuotedStr(ApplicationID));

    For Contador := 0 to UserPermis.TreeMenu.Items.Count -1 do
      if PTreeMenu(UserPermis.TreeMenu.Items[Contador].Data).Selecionado = 1 then
        actIncPermiss(TempIdUser, ApplicationID, PTreeMenu(UserPermis.TreeMenu.Items[Contador].Data).MenuName);

    For Contador := 0 to UserPermis.TreeAction.Items.Count -1 do
      if PTreeAction(UserPermis.TreeAction.Items[Contador].Data).Selecionado = 1 then
        actIncPermiss( TempIdUser, ApplicationID, PTreeAction(UserPermis.TreeAction.Items[Contador].Data).MenuName);
    UserPermis.Close;
  end;

  // Cadastro de perfil
  procedure TDBISAMUserControl.btPerfAdicClick(Sender: TObject);
  begin
    IncPerfil := TIncPerfil.Create(FormPerfilUsuarios);
    TCadPerfil(FormPerfilUsuarios).SetWindow(True);
    IncPerfil.btGravar.OnClick := btIncPerGravarClick;
    IncPerfil.ShowModal;
    FreeAndNil(IncPerfil);
  end;

  procedure TDBISAMUserControl.BtPerAltClick(Sender: TObject);
  begin
    if TCadPerfil(FormPerfilUsuarios).DSPerfilUser.RecordCount = 0 then Exit;
    IncPerfil := TIncPerfil.Create(FormPerfilUsuarios);
    IncPerfil.btGravar.OnClick := btIncPerGravarClick;
    TCadPerfil(FormPerfilUsuarios).SetWindow(False);
    With IncPerfil do
    begin
      FAltera := True;
      EditDescricao.Text := TCadPerfil(FormPerfilUsuarios).DSPerfilUser.FieldByName('Nome').asString;
      ShowModal;
    end;
    FreeAndNil(IncPerfil);
  end;

  procedure TDBISAMUserControl.BtPerExcluiClick(Sender: TObject);
  var
    TempID : Integer;
    CanDelete : Boolean;
    ErrorMsg : String;
  begin
    if TCadPerfil(FormPerfilUsuarios).DSPerfilUser.RecordCount = 0 then Exit;
    TempID := TCadPerfil(FormPerfilUsuarios).DSPerfilUser.fieldByName('IDUser').asInteger;

    with UCGetSQLDataset('Select IdUser from '+ TableUsers +
                          ' Where tipo = ' + QuotedStr('U') + ' AND Perfil = ' + IntToStr(TempID)) do
    begin
      if FieldByName('IdUser').asInteger > 0 then
      begin
        Close;
        Free;
        if MessageDlg(Format(Settings.UsersProfile.PromptDelete, [TCadPerfil(FormPerfilUsuarios).DSPerfilUser.fieldByName('Nome').asString]), mtConfirmation, [mbYes,mbNo], 0)<> mrYes then exit;
      end else begin
        Close;
        Free;
      end;
    end;

    CanDelete := True;
    if Assigned(onDeleteProfile) then onDeleteProfile(Self, TempID, CanDelete, ErrorMsg);
    if Not CanDelete then begin
      MessageDlg(ErrorMSG, mtWarning, [mbOK], 0);
      Exit;
    end;

    UCExecSQL('Delete from '+ TableUsers + ' where IDUser = '+ IntToStr(TempID));
    UCExecSQL('Delete from '+ TableRights + ' where IDUser = '+ IntToStr(TempID));
    UCExecSQL('Update '+ TableUsers +' Set Perfil = null where IDUser = '+ IntToStr(TempID));
    TCadPerfil(FormPerfilUsuarios).DsPerfilUser.Close;
    TCadPerfil(FormPerfilUsuarios).DsPerfilUser.Open;
  end;

  procedure TDBISAMUserControl.btIncPerGravarClick(Sender: TObject);
  var
    FNewIdUser : integer;
    FProfile : String;
  begin
    IncPerfil.btGravar.Enabled := False;
    if not IncPerfil.FAltera then
    begin // inclui perfil
      FNewIdUser := GetNewIdUser;
      FProfile := IncPerfil.EditDescricao.Text;
      if Assigned(onAddProfile) then onAddProfile(Self, FProfile);


      UCExecSQL('INSERT INTO ' + TableUsers +
                     ' ( IdUser, Nome, Tipo )  Values ( '+
                     IntToStr(FNewIdUser) + ', '+
                     QuotedStr(FProfile) + ', '+
                     QuotedStr('P')+ ')');
    end else begin // alterar perfil
      FNewIdUser := TCadPerfil(FormPerfilUsuarios).DSPerfilUser.FieldByName('IdUser').asInteger;
      FProfile := IncPerfil.EditDescricao.Text;


      UCExecSQL('UPDATE '+ TableUsers + ' SET '+
                     ' Nome = '+ QuotedStr(FProfile)+
                     ' Where IdUser = '+ IntToStr(FNewIdUser));
    end;


    TCadPerfil(FormPerfilUsuarios).DSPerfilUser.Close;
    TCadPerfil(FormPerfilUsuarios).DSPerfilUser.Open;
    TCadPerfil(FormPerfilUsuarios).DSPerfilUser.Locate('IDUser',FNewIdUser,[]);
    IncPerfil.Close;
  end;

  // Log do sistema
  procedure TDBISAMUserControl.LogFormShow(Sender: TObject);
  var
    FTabUser, FTabLog : String;
  begin
    with TViewLog(FormLogControl) do
    begin
      with DBIGetQuery do begin
        SQL.Text :='Select idUser, Nome from ' + TableUsers +
                          ' where tipo = '+ QuotedStr('U')+' order by nome';
        Open;
        ComboUsuario.Items.Append('Todos');
        ListIdUser.Append('0');
        while not eof do
        begin
          ComboUsuario.Items.Append(FieldByName('Nome').asString);
          ListIdUser.Append(FieldByName('idUser').asString);
          Next;
        end;
        Close;
        Free;
      end;
      ComboUsuario.ItemIndex := 0;

      FTabUser := TableUsers;
      FTabLog := LogControl.TableLog;

      TDBISAMQuery(DSLog).Sql.Text := 'Select '+ FTabUser+ '.Nome, '+FTabLog+'.* from '+FTabLog +
                                               ' Left outer join '+ FTabUser + ' on '+ FTabLog+'.idUser = '+FTabUser+'.idUser '+
                                               ' Where (data >=' + QuotedStr(FormatDateTime('yyyyMMddhhmmss',data1.DateTime)) + ') and (Data<='+ QuotedStr(FormatDateTime('yyyyMMddhhmmss',data2.DateTime)) +') order by data desc';
      DSLog.Open;
      DataSource1.Dataset := DSLog;
    end;
  end;

  procedure TDBISAMUserControl.btexcluiClick(Sender: TObject);
  var
    FTabUser, FTabLog : String;
  begin
    with TViewLog(FormLogControl) do
    begin
      if MessageDlg(Const_LogC_ConfirmaExcluir, mtConfirmation, [mbYes,mbNo], 0) <> mrYes then exit;
      btFiltro.Enabled := False;
      FTabUser := TableUsers;
      FTabLog := LogControl.TableLog;

      With DBIGetQuery do begin
        SQL.Text := 'Delete from '+FTabLog +
                    ' Where (data >=' + QuotedStr(FormatDateTime('yyyyMMddhhmmss',data1.DateTime)) + ') and (Data<='+ QuotedStr(FormatDateTime('yyyyMMddhhmmss',data2.DateTime)) +
                    ' ) and nivel <= ' + IntToStr(ComboNivel.ItemIndex);
        if ComboUsuario.ItemIndex > 0 then SQL.Text := SQL.Text + ' and '+FTabLog+'.idUser = ' + ListIdUser[ComboUsuario.ItemIndex];
        ExecSQL;
        Free;
      end;

      Log(Format('Efetuada exclusao de log do sistema : Usuario = %s | Data = %s a %s | Nivel <= %s',[comboUsuario.text, DateTimeToStr(Data1.datetime), DateTimeToStr(Data2.datetime), ComboNivel.text ]),2);
      DSLog.Close;
      DSLog.Open;
    end;
  end;

  procedure TDBISAMUserControl.btfiltroClick(Sender: TObject);
  begin
    with TViewLog(FormLogControl) do
    begin
      btFiltro.Enabled := False;
      DSLog.Close;
      TDBISAMQuery(DSLog).SQL.Text := 'Select '+ TableUsers+ '.Nome, '+LogControl.TableLog+'.* from '+LogControl.TableLog +
                            ' Left outer join '+ TableUsers + ' on '+ LogControl.TableLog+'.idUser = '+TableUsers+'.idUser '+
                            ' Where (data >=' + QuotedStr(FormatDateTime('yyyyMMddhhmmss',data1.DateTime)) + ') and (Data<='+ QuotedStr(FormatDateTime('yyyyMMddhhmmss',data2.DateTime)) +
                            ' ) and nivel >= ' + IntToStr(ComboNivel.ItemIndex);
      if ComboUsuario.ItemIndex > 0 then TDBISAMQuery(DsLog).SQL.Text := TDBISAMQuery(DSLog).SQL.Text + ' and '+LogControl.TableLog+'.idUser = ' + ListIdUser[ComboUsuario.ItemIndex];
      TDBISAMQuery(DSLog).SQL.Text := TDBISAMQuery(DSLog).SQL.Text +' order by data desc';
      DSLog.Open;
    end;
  end;

end.
