unit DBXUserControl;

interface

uses
  SysUtils, Classes, UCDefine, UCConsts, UCMessages, DBXpress,
  DB, SqlExpr, FMTBcd, Dialogs, Menus, ActnList, Controls,
  {$IFDEF VER150} SimpleDS {$ELSE} DBLocalS {$ENDIF};

type
  TDBXUserControl = class(TUCDefine)
  private
    FConnection : TSQLConnection;
    FSchemaName: String;
    procedure SetSQLConnection(Value : TSQLConnection);

  protected
    procedure CriaCadUserForm;override;
    procedure CriaProfileUserForm;override;
    procedure ActionLog(Sender : TObject); override;
    procedure ActionBtPermiss(Sender : TObject);override;
    procedure ActionBtPermissProfile(Sender: TObject);override;
    procedure Notification(AComponent: TComponent; Operation: TOperation);override;
    procedure UCExecSQL(FSQL: String);override;
    function UCGetSQLDataset(FSQL : String) : TDataset;override;
    function UCFindTable(const Tablename : String) : Boolean; override;
    function UCFindDataConnection : Boolean; override;
    procedure btfiltroClick(Sender: TObject);
    procedure LogFormShow(Sender: TObject);
    procedure btexcluiClick(Sender: TObject);
  public
    property CurrentUser;
  published
    property SQLConnection : TSQLConnection read FConnection write SeTSQLConnection;
    property SchemaName : String read FSchemaName write FSchemaName;
  end;



procedure Register;

implementation

uses UserPermis_U, CadUser_U, CadPerfil_U, TrocaSenha_U, LoginWindow_U,
  ViewLog_U;

{ TDBXUserControl }


procedure TDBXUserControl.ActionBtPermiss(Sender: TObject);
begin
  inherited;
  UserPermis.TempIdUser := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IdUser').asInteger;

  UserPermis.DSPermiss := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IdUser').asString + ' and Modulo = ' + QuotedStr(ApplicationID));
  UserPermis.DSPermiss.Open;

  UserPermis.DSCmd := TSQLQuery.Create(self);

  TSQLQuery(UserPermis.DSCmd).SQLConnection := FConnection;
  {$IFDEF VER150}
    TSQLQuery(UserPermis.DSCmd). SchemaName := FSchemaName;
  {$ENDIF}

  UserPermis.DSPerfil := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + IntToStr(TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Perfil').asInteger) + ' and Modulo = ' + QuotedStr(ApplicationID));
  UserPermis.DSPerfil.Open;

  UserPermis.ShowModal;
  FreeAndNil(UserPermis);
end;

procedure TDBXUserControl.ActionBtPermissProfile(Sender: TObject);
begin
  inherited;
  UserPermis.TempIdUser := TCadPerfil(FormPerfilUsuarios).DSPerfilUser.FieldByName('IdUser').asInteger;

  UserPermis.DSPermiss := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + TCadPerfil(FormPerfilUsuarios).DSPerfilUser.FieldByName('IdUser').asString + ' and Modulo = ' + QuotedStr(ApplicationID));
  UserPermis.DSPermiss.Open;

  UserPermis.DSCmd := TSQLQuery.Create(self);
  TSQLQuery(UserPermis.DSCmd).SQLConnection := FConnection;
  {$IFDEF VER150}
  TSQLQuery(UserPermis.DSCmd).SchemaName := FSchemaName;
  {$ENDIF}


  UserPermis.DSPerfil := TDataset.Create(nil);

  UserPermis.ShowModal;
  FreeAndNil(UserPermis);
end;

procedure TDBXUserControl.CriaCadUserForm;
begin
  inherited;
  TCadUser(FormCadastroUsuarios).DSCadUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios+ ' Where Tipo = '+QuotedStr('U')+' ORDER BY Login');
  TCadUser(FormCadastroUsuarios).DSCadUser.Open;
  TCadUser(FormCadastroUsuarios).DBGrid1.Columns[0].Title.Caption := Settings.UsersForm.ColName;
  TCadUser(FormCadastroUsuarios).DBGrid1.Columns[1].Title.Caption := Settings.UsersForm.ColLogin;
  TCadUser(FormCadastroUsuarios).DBGrid1.Columns[2].Title.Caption := Settings.UsersForm.ColEmail;

  TCadUser(FormCadastroUsuarios).DScmd := TSQLQuery.Create(self);
  TSQLQuery(TCadUser(FormCadastroUsuarios).DSCMD).SQLConnection := FConnection;
  {$IFDEF VER150}
  TSQLQuery(TCadUser(FormCadastroUsuarios).DSCMD).SchemaName := FSchemaName;
  {$ENDIF}

  TCadUser(FormCadastroUsuarios).DSPerfilUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios+ ' Where Tipo = '+QuotedStr('P')+' ORDER BY Nome');
  TCadUser(FormCadastroUsuarios).DSPerfilUser.Open;
end;

procedure TDBXUserControl.CriaProfileUserForm;
begin
  inherited;
  TCadPerfil(FormPerfilUsuarios).DSPerfilUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios +' Where Tipo = '+QuotedStr('P'));
  TCadPerfil(FormPerfilUsuarios).DSPerfilUser.Open;
  TCadPerfil(FormPerfilUsuarios).DBGrid1.Columns[0].Title.Caption := Settings.UsersProfile.ColProfile;

  TCadPerfil(FormPerfilUsuarios).DSCmd := TSQLQuery.Create(self);
  TSQLQuery(TCadPerfil(FormPerfilUsuarios).DSCmd).SQLConnection := FConnection;
  {$IFDEF VER150}
  TSQLQuery(TCadPerfil(FormPerfilUsuarios).DSCmd).SchemaName := FSchemaName;
  {$ENDIF}

end;

procedure TDBXUserControl.SetSQLConnection(Value: TSQLConnection);
begin
  if FConnection <> Value then FConnection := Value;
  if FConnection <> nil then FConnection.FreeNotification(Self);
end;

procedure Register;
begin
  RegisterComponents('User Control', [TDBXUserControl]);
end;


procedure TDBXUserControl.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  if (Operation = opRemove) and (AComponent = FConnection) then
  begin
    FConnection := nil;
  end;
  inherited Notification(AComponent, Operation);
end;

procedure TDBXUserControl.ActionLog(Sender: TObject);
begin
  inherited;
  TViewLog(FormLogControl).OnShow := LogFormShow;
  TViewLog(FormLogControl).btfiltro.OnClick := btfiltroClick;
  TViewLog(FormLogControl).btexclui.OnClick :=  btexcluiClick;
  TViewLog(FormLogControl).DSLog := UCGetSQLDataset('');

  TViewLog(FormLogControl).ShowModal;
  FreeAndNil(FormLogControl);
end;


procedure TDBXUserControl.UCExecSQL(FSQL: String);
begin
  FConnection.ExecuteDirect(FSQL);
end;

function TDBXUserControl.UCGetSQLDataset(FSQL: String): TDataset;
begin
  {$IFDEF VER150}
  Result := TSimpleDataSet.Create(nil);
  with Result as TSimpleDataSet do
  begin
    Connection := FConnection;
    Dataset.CommandText := FSQL;
  {$ELSE}
  Result := TSQLClientDataSet.Create(nil);
  with Result as TSQLClientDataSet do
  begin
    DBConnection := FConnection;
    CommandText := FSQL;
  {$ENDIF}
    if FSQL <> '' then Open;
  end;

end;


function TDBXUserControl.UCFindTable(const TableName: String): Boolean;
var
  TempList : TStringList;
begin
  try
    TempList := TStringList.Create;
    FConnection.GetTableNames(TempList,False);
    TempList.Text := UpperCase(TempList.Text);
    Result := TempList.IndexOf(UpperCase(TableName)) > -1;
  finally
    FreeAndNil(TempList);
  end;
end;

function TDBXUserControl.UCFindDataConnection: Boolean;
begin
    Result := Assigned(FConnection);
end;


// Procedures desviadadas por motivos de imcompatibilidade entre IProviderSupport e ZeosDBO

  // Log do sistema
  procedure TDBXUserControl.LogFormShow(Sender: TObject);
  var
    FTabUser, FTabLog : String;
  begin
    with TViewLog(FormLogControl) do
    begin
      with UCGetSQLDataset('Select idUser, Nome from ' + TableUsers +
                           ' where tipo = '+ QuotedStr('U')+' order by nome') do
      begin
        ComboUsuario.Items.Append('Todos');
        ListIdUser.Append('0');
        while not eof do
        begin
          ComboUsuario.Items.Append(FieldByName('Nome').asString);
          ListIdUser.Append(FieldByName('idUser').asString);
          Next;
        end;
        Close;
        Free;
      end;
      ComboUsuario.ItemIndex := 0;

      FTabUser := TableUsers;
      FTabLog := LogControl.TableLog;
      DSLog.Close;
      DSLog := UCGetSQLDataset('Select '+ FTabUser+ '.Nome, '+FTabLog+'.* from '+FTabLog +
                                               ' Left outer join '+ FTabUser + ' on '+ FTabLog+'.idUser = '+FTabUser+'.idUser '+
                                               ' Where (data >=' + QuotedStr(FormatDateTime('yyyyMMddhhmmss',data1.DateTime)) + ') and (Data<='+ QuotedStr(FormatDateTime('yyyyMMddhhmmss',data2.DateTime)) +') order by data desc');
      DataSource1.Dataset := DSLog;
    end;
  end;

  procedure TDBXUserControl.btfiltroClick(Sender: TObject);
  var
    TempSQL : String;
  begin
    with TViewLog(FormLogControl) do
    begin
      btFiltro.Enabled := False;
      DSLog.Close;
      TempSQL := 'Select '+ TableUsers+ '.Nome, '+LogControl.TableLog+'.* from '+LogControl.TableLog +
                            ' Left outer join '+ TableUsers + ' on '+ LogControl.TableLog+'.idUser = '+TableUsers+'.idUser '+
                            ' Where (data >=' + QuotedStr(FormatDateTime('yyyyMMddhhmmss',data1.DateTime)) + ') and (Data<='+ QuotedStr(FormatDateTime('yyyyMMddhhmmss',data2.DateTime)) +
                            ' ) and nivel >= ' + IntToStr(ComboNivel.ItemIndex);
      if ComboUsuario.ItemIndex > 0 then TempSQL := TempSQL + ' and '+LogControl.TableLog+'.idUser = ' + ListIdUser[ComboUsuario.ItemIndex];
      TempSQL := TempSQL + ' order by data desc';

      DSLog := UCGetSQLDataset(TempSQL);
      DataSource1.Dataset := DSLog;
    end;
  end;
  procedure TDBXUserControl.btexcluiClick(Sender: TObject);
  var
    FTabUser, FTabLog, SQLTemp : String;
  begin
    with TViewLog(FormLogControl) do
    begin
      if MessageDlg(Const_LogC_ConfirmaExcluir, mtConfirmation, [mbYes,mbNo], 0) <> mrYes then exit;
      btFiltro.Enabled := False;
      FTabUser := TableUsers;
      FTabLog := LogControl.TableLog;
      SQLTemp := 'Delete from '+FTabLog +
                 ' Where (data >=' + QuotedStr(FormatDateTime('yyyyMMddhhmmss',data1.DateTime)) + ') and (Data<='+ QuotedStr(FormatDateTime('yyyyMMddhhmmss',data2.DateTime)) +
                 ' ) and nivel <= ' + IntToStr(ComboNivel.ItemIndex);
      if ComboUsuario.ItemIndex > 0 then SQLTemp := SQLTemp + ' and '+FTabLog+'.idUser = ' + ListIdUser[ComboUsuario.ItemIndex];
      FConnection.ExecuteDirect(SQLTemp);

      Log(Format('Efetuada exclusao de log do sistema : Usuario = %s | Data = %s a %s | Nivel <= %s',[comboUsuario.text, DateTimeToStr(Data1.datetime), DateTimeToStr(Data2.datetime), ComboNivel.text ]),2);
      DSLog.Close;
      DSLog.Open;
    end;
  end;

end.
