unit IncUser_U;

interface

uses
{$IFDEF Ver130}
{$ELSE}
  Variants,
{$ENDIF}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  DB, Dialogs, Buttons, ExtCtrls, StdCtrls, DBCtrls;

type
  TIncUser = class(TForm)
    Panel1: TPanel;
    LbDescricao: TLabel;
    Image1: TImage;
    Panel3: TPanel;
    btGravar: TSpeedButton;
    btCancela: TSpeedButton;
    Panel2: TPanel;
    lbNome: TLabel;
    EditNome: TEdit;
    lbLogin: TLabel;
    EditLogin: TEdit;
    lbEmail: TLabel;
    EditEmail: TEdit;
    ckPrivilegiado: TCheckBox;
    lbPerfil: TLabel;
    ComboPerfil: TDBLookupComboBox;
    btlimpa: TSpeedButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btCancelaClick(Sender: TObject);
    procedure btGravarClick(Sender: TObject);
    function GetNewIdUser : Integer;
    procedure btlimpaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    FAltera : Boolean;
  end;

var
  IncUser: TIncUser;

implementation

uses UCDefine, CadUser_U;

{$R *.dfm}

procedure TIncUser.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  action := caFree;
end;

procedure TIncUser.btCancelaClick(Sender: TObject);
begin
  Close;
end;

procedure TIncUser.btGravarClick(Sender: TObject);
var
  FNovasenha, FNome, FLogin, FEmail  : String;
  FNewIdUser, FPerfil : integer;
  FPriv : Boolean;
begin
  btGravar.Enabled := False;
  //IProviderSupport(QDS).PSExecuteStatement('insert into ORIGE VALUES('+quotedStr(Edit1.text)+', '+QuotedStr(edit2.text)+')',x);

  with IProviderSupport(TCadUser(Owner).DSCMD)  do
  begin
    if not FAltera then begin // inclui user
      FNovasenha := LowerCase(Copy(Encrypt(FormatDateTime('zzzmm',Now),TUCDefine(Owner.Owner).EncryptKey),2,6));
      if not Inputquery(Format(TUCDefine(Owner.Owner).Settings.ResetPassword.WindowCaption,[EditLogin.Text]), TUCDefine(Owner.Owner).Settings.ResetPassword.LabelPassword, FNovaSenha) then begin
        MessageDlg(TUCDefine(Owner.Owner).Settings.CommonMessages.BlankPassword, mtWarning, [mbOK], 0);
        FNovasenha := '';
      end;
      FNewIdUser := GetNewIdUser;
      FNome := EditNome.Text;
      FLogin := EditLogin.Text;
      FEmail := EditEmail.Text;
      if ComboPerfil.KeyValue = null then FPerfil := 0 else FPerfil := ComboPerfil.KeyValue;
      FPriv := ckPrivilegiado.Checked;

      if Assigned( TUCDefine(Owner.Owner).OnAddUser) then
        TUCDefine(Owner.Owner).OnAddUser(TObject(owner.Owner), FLogin, FNovaSenha, FNome, FEmail, FPerfil, FPriv);

      PSExecuteStatement('INSERT INTO ' + TUCDefine(Owner.Owner).TableUsers +
                     ' ( IdUser, Nome, Login, Email, Privilegiado, Senha, Tipo, Perfil ) '+
                     ' Values ( '+
                     IntToStr(FNewIdUser) +', '+
                     QuotedStr(FNome) + ', '+
                     QuotedStr(FLogin) + ', '+
                     QuotedStr(FEmail) + ', '+
                     BooltoStr(FPriv)+', '+
                     QuotedStr(Encrypt(FNovaSenha, TUCDefine(Owner.Owner).EncryptKey))+', '+
                     QuotedStr('U')+', '+
                     IntToStr(FPerfil)+')',TCadUser(Owner).FParam);
      {$IFDEF Ver130}
      {$ELSE}
      if (Assigned(TUCDefine(Owner.Owner).MailUserControl)) and (TUCDefine(Owner.Owner).MailUserControl.AdicionaUsuario.Ativo ) then
        try
          TUCDefine(Owner.Owner).MailUserControl.EnviaEmailAdicionaUsuario(FNome, FLogin, Encrypt(FNovaSenha, TUCDefine(Owner.Owner).EncryptKey) , FEmail, IntToStr(FPerfil), TUCDefine(Owner.Owner).EncryptKey);
        except
          on E : Exception do TUCDefine(Owner.Owner).Log(e.Message,2);
        end;
      {$ENDIF}
    end else begin // alterar user
      FNewIdUser := TCadUser(Owner).DSCadUser.FieldByName('IdUser').asInteger;
      FNome := EditNome.Text;
      FLogin := EditLogin.Text;
      FEmail := EditEmail.Text;
      if ComboPerfil.KeyValue = null then FPerfil := 0 else FPerfil := ComboPerfil.KeyValue;
      FPriv := ckPrivilegiado.Checked;

      if Assigned( TUCDefine(Owner.Owner).OnChangeUser) then
        TUCDefine(Owner.Owner).OnChangeUser(TObject(owner.Owner),FNewIdUser, FLogin, FNome, FEmail, FPerfil, FPriv);


      PSExecuteStatement('UPDATE '+ TUCDefine(Owner.Owner).TableUsers + ' SET '+
                     'Nome = '+ QuotedStr(FNome) + ', '+
                     'Login = '+ QuotedStr(FLogin) + ', '+
                     'Email = '+ QuotedStr(FEmail) +', '+
                     'Privilegiado = '+ BooltoStr(FPriv)+', '+
                     'Perfil = '+ IntToStr(FPerfil)+
                     ' Where IdUser = ' + IntToStr(FNewIdUser),TCadUser(Owner).FParam);

      {$IFDEF Ver130}
      {$ELSE}
      if (Assigned(TUCDefine(Owner.Owner).MailUserControl)) and (TUCDefine(Owner.Owner).MailUserControl.AlteraUsuario.Ativo ) then
        try
          TUCDefine(Owner.Owner).MailUserControl.EnviaEmailAlteraUsuario(FNome, FLogin, TCadUser(Owner).DSCadUser.FieldByName('senha').asString, FEmail, IntToStr(FPerfil), TUCDefine(Owner.Owner).EncryptKey);
        except
          on E : Exception do TUCDefine(Owner.Owner).Log(e.Message,2);
        end;
      {$ENDIF}
    end;
  end;
  TCadUser(Owner).DSCadUser.Close;
  TCadUser(Owner).DSCadUser.Open;
  TCadUser(Owner).DSCadUser.Locate('IDUser',FNewIdUser,[]);
  Close;
end;

function TIncUser.GetNewIdUser: Integer;
var
  Temp : integer;
begin
  if not Assigned(TCadUser(Owner).DSNewId) then
  begin
    TCadUser(Owner).DSCMD.Close;
    IProviderSupport(TCadUser(Owner).DSCMD).PSSetCommandText('Select Max(IdUser) as IdUser from '+ TUCDefine(Owner.Owner).TableUsers);
    TCadUser(Owner).DSCMD.Open;
    Temp := TCadUser(Owner).DSCMD.FieldByName('IdUser').asInteger+1;
    TCadUser(Owner).DSCMD.Close;
  end else begin
    TCadUser(Owner).DSNewId.Open;
    Temp := TCadUser(Owner).DSNewId.FieldByName('IdUser').asInteger;
    TCadUser(Owner).DSNewId.Close;
  end;
  if Temp = 0 then Result := 1 else Result := Temp;
end;

procedure TIncUser.btlimpaClick(Sender: TObject);
begin
  ComboPerfil.KeyValue := null
end;

procedure TIncUser.FormCreate(Sender: TObject);
begin
  if not TUCDefine(Owner.Owner).UsersProfile.Active then begin
    lbPerfil.Visible := False;
    ComboPerfil.Visible := False;
    btLimpa.Visible := False;
  end;
  ckPrivilegiado.Visible := TUCDefine(Owner.Owner).UsersForm.UsePrivilegedField;
end;

procedure TIncUser.FormShow(Sender: TObject);
begin
  if (TUCDefine(Owner.Owner).UsersForm.ProtectAdmin) and (EditLogin.Text = TUCDefine(Owner.Owner).Login.InitialLogin.User) then EditLogin.Enabled := False;
end;

end.


