unit ViewLog_U;

interface

uses
{$IFDEF Ver130}
{$ELSE}
  Variants,
{$ENDIF}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, DBGrids, DB,
  Buttons, ComCtrls, ImgList, UCConsts;

type
  TViewLog = class(TForm)
    Panel1: TPanel;
    lbDescricao: TLabel;
    Image1: TImage;
    Panel2: TPanel;
    Splitter1: TSplitter;
    Panel3: TPanel;
    lbUsuario: TLabel;
    ComboUsuario: TComboBox;
    Bevel1: TBevel;
    lbData: TLabel;
    data1: TDateTimePicker;
    data2: TDateTimePicker;
    Bevel2: TBevel;
    lbNivel: TLabel;
    ComboNivel: TComboBox;
    btfiltro: TSpeedButton;
    Bevel3: TBevel;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    ImageList1: TImageList;
    btfecha: TSpeedButton;
    btexclui: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure ComboNivelDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormShow(Sender: TObject);
    procedure DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure ComboUsuarioChange(Sender: TObject);
    procedure btfechaClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btexcluiClick(Sender: TObject);
    procedure data1Change(Sender: TObject);
    procedure btfiltroClick(Sender: TObject);
  private

  public
    ListIdUser : TStringList;
    DSLog, DSCmd : TDataset;
    FParam : TParams;
  end;

var
  ViewLog: TViewLog;

implementation
uses UCDefine;
{$R *.dfm}

procedure TViewLog.FormCreate(Sender: TObject);
begin
  ComboNivel.Items.Clear;
  ComboNivel.Items.Append(Const_LogC_Low);        //BGM
  ComboNivel.Items.Append(Const_LogC_Normal);     //BGM
  ComboNivel.Items.Append(Const_LogC_High);       //BGM
  ComboNivel.Items.Append(Const_LogC_Critic);     //BGM
  ComboNivel.ItemIndex := 0;
  ComboUsuario.Items.Clear;
  ListIdUser := TStringList.Create;
  data1.Date := EncodeDate(StrToInt(FormatDateTime('yyyy',date)),1,1);
  data2.DateTime := now;
  FParam := TParams.Create;
end;

procedure TViewLog.ComboNivelDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  TempImg : TBitmap;
begin
  TempImg := TBitmap.Create;
  Imagelist1.GetBitmap(index,TempImg);
  ComboNivel.Canvas.Draw(Rect.Left+2,Rect.Top+1, TempImg);
  ComboNivel.Canvas.TextRect(Rect,Rect.Left+20,Rect.Top +2, ComboNivel.items[index]);
  ComboNivel.Canvas.Draw(Rect.Left+2,Rect.Top+1, TempImg);
  FreeAndNil(TempImg);
end;

procedure TViewLog.FormShow(Sender: TObject);
var
  FTabUser, FTabLog : String;
begin
  IProviderSupport(DSCmd).PSSetCommandText('Select idUser, Nome from ' + TUCDefine(Owner).TableUsers +
                                           ' where tipo = '+ QuotedStr('U')+' order by nome');
  DSCMD.Open;
  ComboUsuario.Items.Append(Const_LogC_Todos);     //BGM
  ListIdUser.Append('0');
  while not DSCMD.eof do begin
    ComboUsuario.Items.Append(DSCMD.FieldByName('Nome').asString);
    ListIdUser.Append(DSCMD.FieldByName('idUser').asString);
    DSCMD.Next;
  end;
  DSCMD.Close;

  ComboUsuario.ItemIndex := 0;

  FTabUser := TUCDefine(Owner).TableUsers;
  FTabLog := TUCDefine(Owner).LogControl.TableLog;
  IProviderSupport(DSLog).PSSetCommandText('Select '+ FTabUser+ '.Nome, '+FTabLog+'.* from '+FTabLog +
                        ' Left outer join '+ FTabUser + ' on '+ FTabLog+'.idUser = '+FTabUser+'.idUser '+
                        ' Where (data >=' + QuotedStr(FormatDateTime('yyyyMMddhhmmss',data1.DateTime)) + ') and (Data<='+ QuotedStr(FormatDateTime('yyyyMMddhhmmss',data2.DateTime)) +') order by data desc');
  DSLog.Open;
  DataSource1.Dataset := DSLog;
end;

procedure TViewLog.DBGrid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  TempImg : TBitmap;
  FData : TDateTime;
  TempData : String;
begin
  if DSLog.RecordCount = 0 then Exit;
  if LowerCase(Column.FieldName) = 'nivel' then begin
    TempImg := TBitmap.Create;
    imagelist1.GetBitmap( Column.Field.AsInteger , TempImg);
    DbGrid1.Canvas.Draw(rect.Left+5,rect.Top,Tempimg);
    FreeAndNil(TempImg);
  end else if LowerCase(Column.FieldName) = 'data' then begin
    TempData := Column.Field.AsString;
    FData := EncodeDate( StrToInt(Copy(Tempdata,1,4)), StrToInt(Copy(Tempdata,5,2)), StrToInt(Copy(Tempdata,7,2)) ) +
             EncodeTime( StrToInt(Copy(TempData, 9,2)), StrToInt(Copy(TempData,11,2)), StrToInt(Copy(TempData,13,2)),0);
    DbGrid1.Canvas.TextRect(Rect,Rect.Left+2,Rect.Top+2, DateTimeToStr(FData));
  end else DbGrid1.Canvas.TextRect(Rect,Rect.Left+2,Rect.Top+2, Column.Field.AsString);
end;

procedure TViewLog.ComboUsuarioChange(Sender: TObject);
begin
  btFiltro.Enabled := True;
end;

procedure TViewLog.btfechaClick(Sender: TObject);
begin
  Close;
end;

procedure TViewLog.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  action := caFree;
end;

procedure TViewLog.btexcluiClick(Sender: TObject);
var
  FTabUser, FTabLog, Temp : String;
begin
  if MessageDlg(Const_LogC_ConfirmaExcluir, mtConfirmation, [mbYes,mbNo], 0) <> mrYes then exit;
  btFiltro.Enabled := False;
  FTabUser := TUCDefine(Owner).TableUsers;
  FTabLog := TUCDefine(Owner).LogControl.TableLog;
  Temp := 'Delete from '+FTabLog +
                        ' Where (data >=' + QuotedStr(FormatDateTime('yyyyMMddhhmmss',data1.DateTime)) + ') and (Data<='+ QuotedStr(FormatDateTime('yyyyMMddhhmmss',data2.DateTime)) +
                        ' ) and nivel <= ' + IntToStr(ComboNivel.ItemIndex);

  if ComboUsuario.ItemIndex > 0 then
    Temp := Temp + ' and '+FTabLog+'.idUser = ' + ListIdUser[ComboUsuario.ItemIndex];

  try
  IProviderSupport(DSCMD).PSExecuteStatement(Temp, FParam);
  except
  end;

  TUCDefine(Owner).Log(Format('Efetuada exclusao de log do sistema : Usuario = "%s" | Data = %s a %s | Nvel <= %s',[comboUsuario.text, DateTimeToStr(Data1.datetime), DateTimeToStr(Data2.datetime), ComboNivel.text ]),2);

  DSLog.Close;
  DSLog.Open;
end;

procedure TViewLog.data1Change(Sender: TObject);
begin
  btFiltro.Enabled := True;
end;

procedure TViewLog.btfiltroClick(Sender: TObject);
var
  FTabUser, FTabLog : String;
  Temp : String;
begin
  btFiltro.Enabled := False;
  DSLog.Close;
  FTabUser := TUCDefine(Owner).TableUsers;
  FTabLog := TUCDefine(Owner).LogControl.TableLog;
  Temp := 'Select '+ FTabUser+ '.Nome, '+FTabLog+'.* from '+FTabLog +
          ' Left outer join '+ FTabUser + ' on '+ FTabLog+'.idUser = '+FTabUser+'.idUser '+
          ' Where (data >=' + QuotedStr(FormatDateTime('yyyyMMddhhmmss',data1.DateTime)) + ') and (Data<='+ QuotedStr(FormatDateTime('yyyyMMddhhmmss',data2.DateTime)) +
          ' ) and nivel >= ' + IntToStr(ComboNivel.ItemIndex);
  if ComboUsuario.ItemIndex > 0 then Temp := Temp + ' and '+FTabLog+'.idUser = ' + ListIdUser[ComboUsuario.ItemIndex];
  Temp := Temp +' order by data desc';
  IProviderSupport(DSLog).PSSetCommandText(Temp);
  DSLog.Open;
end;

end.
