unit Zeos5UserControl;

interface

uses
{$IFDEF Ver130}
{$ELSE}
  Variants,
{$ENDIF}
  SysUtils, Classes, UCDefine, UCConsts, UCMessages, DB, Dialogs,
  Menus, ActnList, Controls, ZTransact, ZMsSqlTr, ZConnect,
  ZMsSqlCon, ZQuery, ZMsSqlQuery, ZIbSqlQuery, ZIbSqlTr, ZIbSqlCon,
  ZMySqlQuery, ZMySqlTr, ZMySqlCon, ZOraSqlQuery, ZOraSqlTr, ZOraSqlCon,
  ZSySqlQuery, ZSySqlTr, ZSySqlCon, ZDb2SqlQuery, ZDb2SqlTr,
  ZDb2SqlCon, ZPgSqlQuery, ZPgSqlTr,ZPgSqlCon;

type
  TZeos5UserControl = class(TUCDefine)
  private
    FTransAction: TZTransact;
    procedure SetFTransAction(const Value: TZTransact);
    procedure actBtPassClick(Sender: TObject);
    procedure actIncPermiss(idUser: Integer; Modulo, ObjName: String);
    procedure btexcluiClick(Sender: TObject);
    procedure BtExcluiUserClick(Sender: TObject);
    procedure btfiltroClick(Sender: TObject);
    procedure BtGravaPermissClick(Sender: TObject);
    procedure BtGravaPermissPerfilClick(Sender: TObject);
    procedure btGravarUsuarioClick(Sender: TObject);
    procedure btIncPerGravarClick(Sender: TObject);
    procedure BtPerAltClick(Sender: TObject);
    procedure BtPerExcluiClick(Sender: TObject);
    procedure btPerfAdicClick(Sender: TObject);
    procedure btUserAdicClick(Sender: TObject);
    procedure BtUserAltClick(Sender: TObject);
    function GetNewIdUser: Integer;
    procedure LogFormShow(Sender: TObject);
    function ZGetQuery: TZDataset;
  protected
    procedure CriaCadUserForm;override;
    procedure CriaProfileUserForm;override;
    procedure ActionLog(Sender : TObject); override;
    procedure ActionBtPermiss(Sender : TObject);override;
    procedure ActionBtPermissProfile(Sender: TObject);override;
    procedure Notification(AComponent: TComponent; Operation: TOperation);override;
    procedure UCExecSQL(FSQL: String);override;
    function UCGetSQLDataset(FSQL : String) : TDataset;override;
    function UCFindTable(const Tablename : String) : Boolean; override;
    function UCFindDataConnection : Boolean; override;
  public
    property CurrentUser;
  published
    property ZeosTransaction : TZTransact read FTransAction write SetFTransAction;
  end;



procedure Register;

implementation

uses UserPermis_U, CadUser_U, CadPerfil_U, TrocaSenha_U, LoginWindow_U,
  ViewLog_U, IncUser_U, IncPerfil_U;

{ TZeos5UserControl }

function TZeos5UserControl.ZGetQuery : TZDataset;
var
  FQuery: TZDataset;
begin
  if FTransAction is TzMsSQLTransact then begin
    FQuery := Tzmssqlquery.Create(self);
    Tzmssqlquery(FQuery).RequestLive := True;
  end else if FTransAction is TZIbSqlTransact then begin
    FQuery := TZIbSqlQuery.Create(self);
    TZIbSqlQuery(FQuery).RequestLive := True;
  end else if FTransAction is TZMySqlTransact then begin
    FQuery := TZMySqlQuery.Create(self);
    TZMySqlQuery(FQuery).RequestLive := True;
  end else if FTransAction is TZOraSqlTransact then begin
    FQuery := TZOraSqlQuery.Create(self);
    TZOraSqlQuery(FQuery).RequestLive := True;
  end else if FTransAction is TZPgSqlTransact then begin
    FQuery := TZPgSqlQuery.Create(self);
    TZPgSqlQuery(FQuery).RequestLive := True;
  end else if FTransAction is TZDb2SqlTransact then begin
    FQuery := TZDb2SqlQuery.Create(self);
    TZDb2SqlQuery(FQuery).RequestLive := True;
  end else begin //if FTransAction is TZSySqlTransact then begin
    FQuery := TZSySqlQuery.Create(self);
    TZSySqlQuery(FQuery).RequestLive := True;
  end;

  FQuery.Database := FTransAction.Database;
  FQuery.Transaction := FTransAction;
  Result := FQuery;
end;



procedure TZeos5UserControl.SetFTransAction(const Value: TZTransact);
begin
  FTransAction := Value;
  if Value <> nil then Value.FreeNotification(Self);
end;

procedure TZeos5UserControl.ActionBtPermiss(Sender: TObject);
begin
  inherited;
  UserPermis.TempIdUser := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IdUser').asInteger;

  UserPermis.DSPermiss := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IdUser').asString + ' and Modulo = ' + QuotedStr(ApplicationID));
  UserPermis.DSPermiss.Open;

  UserPermis.DSPerfil := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + IntToStr(TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Perfil').asInteger) + ' and Modulo = ' + QuotedStr(ApplicationID));
  UserPermis.DSPerfil.Open;
  UserPermis.BtGrava.OnClick := BtGravaPermissClick;

  UserPermis.ShowModal;
  FreeAndNil(UserPermis);
end;

procedure TZeos5UserControl.ActionBtPermissProfile(Sender: TObject);
begin
  inherited;
  UserPermis.TempIdUser := TCadPerfil(FormPerfilUsuarios).DSPerfilUser.FieldByName('IdUser').asInteger;

  UserPermis.DSPermiss := UCGetSQLDataset('Select * from ' + TableRights + ' Where IdUser = ' + TCadPerfil(FormPerfilUsuarios).DSPerfilUser.FieldByName('IdUser').asString + ' and Modulo = ' + QuotedStr(ApplicationID));
  UserPermis.DSPermiss.Open;

  UserPermis.DSPerfil := TDataset.Create(nil);

  UserPermis.BtGrava.OnClick := BtGravaPermissPerfilClick;

  UserPermis.ShowModal;
  FreeAndNil(UserPermis);
end;

procedure TZeos5UserControl.CriaCadUserForm;
begin
  inherited;
  with TCadUser(FormCadastroUsuarios) do
  begin
    DSCadUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios+ ' Where Tipo = '+QuotedStr('U')+' ORDER BY Login');
    DSCadUser.Open;
    DBGrid1.Columns[0].Title.Caption := Settings.UsersForm.ColName;
    DBGrid1.Columns[1].Title.Caption := Settings.UsersForm.ColLogin;
    DBGrid1.Columns[2].Title.Caption := Settings.UsersForm.ColEmail;

    DSNewId := UCGetSQLDataset('Select Max(IdUser) + 1 as IdUser from '+ TableUsers);

    DSPerfilUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios+ ' Where Tipo = '+QuotedStr('P')+' ORDER BY Nome');
    DSPerfilUser.Open;
    //desvia procedures dos eventos dos botoes
    btAdic.OnClick := btUserAdicClick;
    BtAlt.OnClick := BtUserAltClick;
    BtExclui.OnClick := BtExcluiUserClick;
    BtPass.OnClick := actBtPassClick;
  end;

end;

procedure TZeos5UserControl.CriaProfileUserForm;
begin
  inherited;
  with TCadPerfil(FormPerfilUsuarios) do
  begin
    DSPerfilUser := UCGetSQLDataset('Select * from '+ FTabelaUsuarios +' Where Tipo = '+QuotedStr('P'));
    DSPerfilUser.Open;
    DBGrid1.Columns[0].Title.Caption := Settings.UsersProfile.ColProfile;

    //desvia procedures dos eventos dos botoes
    btAdic.OnClick := btPerfAdicClick;
    BtAlt.OnClick := BtPerAltClick;
    BtExclui.OnClick := BtPerExcluiClick;
  end;
end;

procedure Register;
begin
  RegisterComponents('User Control', [TZeos5UserControl]);
end;


procedure TZeos5UserControl.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  if (Operation = opRemove) and (AComponent = FTransAction) then FTransAction := nil;
  inherited Notification(AComponent, Operation);
end;

procedure TZeos5UserControl.ActionLog(Sender: TObject);
begin
  inherited;
  TViewLog(FormLogControl).OnShow := LogFormShow;
  TViewLog(FormLogControl).btexclui.OnClick := btexcluiClick;
  TViewLog(FormLogControl).btfiltro.OnClick := btfiltroClick;
  TViewLog(FormLogControl).DSLog := ZGetQuery;

  TViewLog(FormLogControl).ShowModal;
  FreeAndNil(FormLogControl);
end;


procedure TZeos5UserControl.UCExecSQL(FSQL: String);
begin
  with ZGetQuery do
  begin
    SQL.Text := FSQL;
    ExecSQL;
    Free;
  end;
end;


function TZeos5UserControl.UCGetSQLDataset(FSQL: String): TDataset;
begin
  Result := ZGetQuery;
  with Result as TZDataset do
  begin
    SQL.text := FSQL;
    Open;
  end;
end;

function TZeos5UserControl.UCFindTable(const TableName: String): Boolean;
var
  TempQuery : TZDataset;
  Lista : TStringList;
begin
  TempQuery := ZGetQuery;
  if FTransAction is TzMsSQLTransact then begin
    TempQuery.Sql.Text := 'select name from sysobjects where type='+QuotedStr('U')+' and name like '+QuotedStr(TableName)+' order by name';
    TempQuery.Open;
    Result := TempQuery.RecordCount > 0;
    TempQuery.Close;
    TempQuery.Free;
  end else if FTransAction is TzIBSQLTransact then begin
    TempQuery.SQL.Text := 'SELECT RDB$RELATION_NAME FROM RDB$RELATIONS WHERE RDB$SYSTEM_FLAG = 0 and RDB$RELATION_NAME = '+QuotedStr(Uppercase(TableName));
    TempQuery.Open;
    Result := TempQuery.RecordCount > 0;
    TempQuery.Close;
    TempQuery.Free;
  end else if FTransAction is TzMySQLTransact then begin
    TempQuery.SQL.Text := 'SHOW TABLES LIKE  '+QuotedStr(Uppercase(TableName));
    TempQuery.Open;
    Result := TempQuery.RecordCount > 0;
    TempQuery.Close;
    TempQuery.Free;
  end else if FTransAction is TzOraSQLTransact then begin
    TempQuery.SQL.Text := 'SELECT TABLE_NAME FROM ALL_TABLES WHERE TABLE_NAME LIKE '+QuotedStr(Uppercase(TableName));
    TempQuery.Open;
    Result := TempQuery.RecordCount > 0;
    TempQuery.Close;
    TempQuery.Free;
  end else if FTransAction is TzPgSQLTransact then begin
    TempQuery.SQL.Text := 'SELECT pg_class.oid as Index, relname as TableName FROM pg_class WHERE relkind = '+QuotedStr('r')+' AND relname !~'+QuotedStr('^pg_')+' AND lower(relname) LIKE '+QuotedStr(LowerCase(TableName));
    TempQuery.Open;
    Result := TempQuery.RecordCount > 0;
    TempQuery.Close;
    TempQuery.Free;
  end else if FTransAction is TzDb2SQLTransact then begin
    TempQuery.SQL.Text := 'SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME LIKE '+QuotedStr(UpperCase(TableName));
    TempQuery.Open;
    Result := TempQuery.RecordCount > 0;
    TempQuery.Close;
    TempQuery.Free;
  end else if FTransAction is TzSySQLTransact then begin
    TempQuery.SQL.Text := 'select name from sysobjects where type='+QuotedStr('U')+' and name like '+QuotedStr(Lowercase(TableName));

    TempQuery.Open;
    Result := TempQuery.RecordCount > 0;
    TempQuery.Close;
    TempQuery.Free;
  end else begin
    Lista := TStringList.Create;
    FTransAction.Database.GetTableNames(UpperCase(TableName),False,Lista);
    Result := Lista.Count > 0;
  end;
end;

function TZeos5UserControl.UCFindDataConnection: Boolean;
begin
    Result := Assigned(FTransAction);
end;



// Procedures desviadadas por motivos de imcompatibilidade entre IProviderSupport e ZeosDBO
  //rotinas do cadastro de usuarios
  function TZeos5UserControl.GetNewIdUser: Integer;
  var
    Temp : Integer;
  begin
    with ZGetQuery do begin
      SQL.Text := 'Select Max(IdUser) + 1 as IdUser from '+ TableUsers;
      Open;
      Temp := Fieldbyname('idUser').asInteger;
      Close;
      Free;
    end;
    if Temp = 0 then Result := 1 else Result := Temp;
  end;

  procedure TZeos5UserControl.btUserAdicClick(Sender: TObject);
  begin
    IncUser := TIncUser.Create(TCadUser(FormCadastroUsuarios));
    TCadUser(FormCadastroUsuarios).SetWindow(True);
    IncUser.btGravar.OnClick := btGravarUsuarioClick;
    IncUser.ShowModal;
    FreeAndNil(IncUser);
  end;

  procedure TZeos5UserControl.BtUserAltClick(Sender: TObject);
  begin
    if TCadUser(FormCadastroUsuarios).DSCadUser.RecordCount = 0 then Exit;
    IncUser := TIncUser.Create(TCadUser(FormCadastroUsuarios));
    IncUser.btGravar.OnClick := btGravarUsuarioClick;
    TCadUser(FormCadastroUsuarios).SetWindow(False);
    With IncUser do begin
      FAltera := True;
      EditNome.Text := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Nome').asString;
      EditLogin.Text := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Login').asString;
      EditEmail.Text := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Email').asString;
      ComboPerfil.KeyValue := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Perfil').asInteger;
      ckPrivilegiado.Checked := StrToBool(TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Privilegiado').asString);
      ShowModal;
    end;
    FreeAndNil(IncUser);
  end;

  procedure TZeos5UserControl.BtExcluiUserClick(Sender: TObject);
  var
    TempID : Integer;
    CanDelete : Boolean;
    ErrorMsg : String;
  begin
    if TCadUser(FormCadastroUsuarios).DSCadUser.RecordCount = 0 then Exit;
    TempID := TCadUser(FormCadastroUsuarios).DSCadUser.fieldByName('IDUser').asInteger;
    if MessageDlg(Format(Settings.UsersForm.PromptDelete, [TCadUser(FormCadastroUsuarios).DSCadUser.fieldByName('Nome').asString]), mtConfirmation, [mbYes,mbNo], 0) = mrYes then
    begin
      CanDelete := True;
      if Assigned(onDeleteUser) then onDeleteUser(TObject(Owner),TempID, CanDelete, ErrorMsg);
      if Not CanDelete then begin
        MessageDlg(ErrorMSG, mtWarning, [mbOK], 0);
        Exit;
      end;
      UCExecSql('Delete from '+ TableUsers + ' where IDUser = '+ IntToStr(TempID));
      UCExecSql('Delete from '+ TableRights + ' where IDUser = '+ IntToStr(TempID));
      TCadUser(FormCadastroUsuarios).DSCadUser.Close;
      TCadUser(FormCadastroUsuarios).DSCadUser.Open;
      TCadUser(FormCadastroUsuarios).DSCadUser.First;

    end;
  end;

  procedure TZeos5UserControl.actBtPassClick(Sender: TObject);
  var
    FNovasenha : String;
  begin
    if TCadUser(FormCadastroUsuarios).DSCadUser.RecordCount = 0 then Exit;
    if Inputquery(Format( Settings.ChangePassword.WindowCaption,[TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('Login').asString]), Settings.ChangePassword.LabelNewPassword ,FNovaSenha) then
    begin
  {$IFDEF VER130}
  {$ELSE}
      if (Assigned(MailUserControl)) and (MailUserControl.SenhaForcada.Ativo ) then
        try
          with TCadUser(FormCadastroUsuarios).DSCadUser do
            MailUserControl.EnviaEmailSenhaForcada(
                                             fieldbyname('nome').asString ,
                                             fieldbyname('login').asString,
                                             Encrypt(FNovasenha, EncryptKey),
                                             fieldbyname('email').asString,
                                             '');
        except
          on E : Exception do Log(e.Message,2);
        end;
  {$ENDIF}
      UCExecSql('UPDATE ' + TableUsers + ' Set Senha = '+ QuotedStr(Encrypt(FNovasenha, EncryptKey)) + ' Where IDUser = ' + TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IDUser').asString);
    end;
  end;

  procedure TZeos5UserControl.btGravarUsuarioClick(Sender: TObject);
  var
    FNovasenha, FNome, FLogin, FEmail  : String;
    FNewIdUser, FPerfil : integer;
    FPriv : Boolean;
  begin
    IncUser.btGravar.Enabled := False;

    if not IncUser.FAltera then
    begin // inclui user
      FNovasenha := LowerCase(Copy(Encrypt(FormatDateTime('zzzmm',Now),EncryptKey),2,6));
      if not Inputquery(Format(Settings.ResetPassword.WindowCaption,[IncUser.EditLogin.Text]), Settings.ResetPassword.LabelPassword, FNovaSenha) then
      begin
        MessageDlg(Settings.CommonMessages.BlankPassword, mtWarning, [mbOK], 0);
        FNovasenha := '';
      end;
      FNewIdUser := GetNewIdUser;
      FNome := IncUser.EditNome.Text;
      FLogin := IncUser.EditLogin.Text;
      FEmail := IncUser.EditEmail.Text;
      if IncUser.ComboPerfil.KeyValue = null then FPerfil := 0 else FPerfil := IncUser.ComboPerfil.KeyValue;
      FPriv := IncUser.ckPrivilegiado.Checked;

      if Assigned( OnAddUser) then OnAddUser(Self, FLogin, FNovaSenha, FNome, FEmail, FPerfil, FPriv);

      UCExecSQL( 'INSERT INTO ' + TableUsers +
                 ' ( IdUser, Nome, Login, Email, Privilegiado, Senha, Tipo, Perfil ) '+
                 ' Values ( '+
                 IntToStr(FNewIdUser) +', '+
                 QuotedStr(FNome) + ', '+
                 QuotedStr(FLogin) + ', '+
                 QuotedStr(FEmail) + ', '+
                 BooltoStr(FPriv)+', '+
                 QuotedStr(Encrypt(FNovaSenha, EncryptKey))+', '+
                 QuotedStr('U')+', '+
                 IntToStr(FPerfil)+')');
      {$IFDEF Ver130}
      {$ELSE}
      if (Assigned(MailUserControl)) and (MailUserControl.AdicionaUsuario.Ativo ) then
        try
          MailUserControl.EnviaEmailAdicionaUsuario(FNome, FLogin, Encrypt(FNovaSenha, EncryptKey) , FEmail, IntToStr(FPerfil), EncryptKey);
        except
          on E : Exception do Log(e.Message,2);
        end;
      {$ENDIF}
    end else begin // alterar user
      FNewIdUser := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IdUser').asInteger;
      FNome := IncUser.EditNome.Text;
      FLogin := IncUser.EditLogin.Text;
      FEmail := IncUser.EditEmail.Text;
      if IncUser.ComboPerfil.KeyValue = null then FPerfil := 0 else FPerfil := IncUser.ComboPerfil.KeyValue;
      FPriv := IncUser.ckPrivilegiado.Checked;

      if Assigned( OnChangeUser) then
        OnChangeUser(Self,FNewIdUser, FLogin, FNome, FEmail, FPerfil, FPriv);


      UCExecSQL('UPDATE '+ TableUsers + ' SET '+
                'Nome = '+ QuotedStr(FNome) + ', '+
                'Login = '+ QuotedStr(FLogin) + ', '+
                'Email = '+ QuotedStr(FEmail) +', '+
                'Privilegiado = '+ BooltoStr(FPriv)+', '+
                'Perfil = '+ IntToStr(FPerfil)+
                ' Where IdUser = ' + IntToStr(FNewIdUser));

      {$IFDEF Ver130}
      {$ELSE}
      if (Assigned(MailUserControl)) and (MailUserControl.AlteraUsuario.Ativo ) then
        try
          MailUserControl.EnviaEmailAlteraUsuario(FNome, FLogin, TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('senha').asString, FEmail, IntToStr(FPerfil), EncryptKey);
        except
          on E : Exception do Log(e.Message,2);
        end;
      {$ENDIF}
    end;
    TCadUser(FormCadastroUsuarios).DSPerfilUser.Close;
    TCadUser(FormCadastroUsuarios).DSPerfilUser.Open;
    TCadUser(FormCadastroUsuarios).DSCadUser.Close;
    TCadUser(FormCadastroUsuarios).DSCadUser.Open;
    TCadUser(FormCadastroUsuarios).DSCadUser.Locate('IDUser',FNewIdUser,[]);
    IncUser.Close;
  end;

  //bt gravar permissoes do usuario
  procedure TZeos5UserControl.actIncPermiss( idUser : Integer; Modulo, ObjName : String);
  begin
    UCExecSQL('INSERT INTO '+ TableRights +
                         '( IdUser, Modulo, ObjName) Values ( '+
                         IntToStr(IdUser) + ', '+
                         QuotedStr(Modulo) + ', '+
                         QuotedStr(ObjName)  +')');
  end;

  procedure TZeos5UserControl.BtGravaPermissClick(Sender: TObject);
  var
    Contador,TempIdUser : Integer;
  begin

    TempIdUser := TCadUser(FormCadastroUsuarios).DSCadUser.FieldByName('IdUser').asInteger;
    UCExecSQL('Delete from '+ TableRights + ' Where IdUser = '+ IntToStr(TempIdUser) + ' and Modulo = '+ QuotedStr(ApplicationID));

    For Contador := 0 to UserPermis.TreeMenu.Items.Count -1 do
      if PTreeMenu(UserPermis.TreeMenu.Items[Contador].Data).Selecionado = 1 then
        actIncPermiss(TempIdUser, ApplicationID, PTreeMenu(UserPermis.TreeMenu.Items[Contador].Data).MenuName);

    For Contador := 0 to UserPermis.TreeAction.Items.Count -1 do
      if PTreeAction(UserPermis.TreeAction.Items[Contador].Data).Selecionado = 1 then
        actIncPermiss( TempIdUser, ApplicationID, PTreeAction(UserPermis.TreeAction.Items[Contador].Data).MenuName);
    UserPermis.Close;
  end;


  procedure TZeos5UserControl.BtGravaPermissPerfilClick(Sender: TObject);
  var
    Contador,TempIdUser : Integer;
  begin

    TempIdUser := TCadPerfil(FormPerfilUsuarios).DsPerfilUser.FieldByName('IdUser').asInteger;
    UCExecSQL('Delete from '+ TableRights + ' Where IdUser = '+ IntToStr(TempIdUser) + ' and Modulo = '+ QuotedStr(ApplicationID));

    For Contador := 0 to UserPermis.TreeMenu.Items.Count -1 do
      if PTreeMenu(UserPermis.TreeMenu.Items[Contador].Data).Selecionado = 1 then
        actIncPermiss(TempIdUser, ApplicationID, PTreeMenu(UserPermis.TreeMenu.Items[Contador].Data).MenuName);

    For Contador := 0 to UserPermis.TreeAction.Items.Count -1 do
      if PTreeAction(UserPermis.TreeAction.Items[Contador].Data).Selecionado = 1 then
        actIncPermiss( TempIdUser, ApplicationID, PTreeAction(UserPermis.TreeAction.Items[Contador].Data).MenuName);
    UserPermis.Close;
  end;

  // Cadastro de perfil
  procedure TZeos5UserControl.btPerfAdicClick(Sender: TObject);
  begin
    IncPerfil := TIncPerfil.Create(FormPerfilUsuarios);
    TCadPerfil(FormPerfilUsuarios).SetWindow(True);
    IncPerfil.btGravar.OnClick := btIncPerGravarClick;
    IncPerfil.ShowModal;
    FreeAndNil(IncPerfil);
  end;

  procedure TZeos5UserControl.BtPerAltClick(Sender: TObject);
  begin
    if TCadPerfil(FormPerfilUsuarios).DSPerfilUser.RecordCount = 0 then Exit;
    IncPerfil := TIncPerfil.Create(FormPerfilUsuarios);
    IncPerfil.btGravar.OnClick := btIncPerGravarClick;
    TCadPerfil(FormPerfilUsuarios).SetWindow(False);
    With IncPerfil do
    begin
      FAltera := True;
      EditDescricao.Text := TCadPerfil(FormPerfilUsuarios).DSPerfilUser.FieldByName('Nome').asString;
      ShowModal;
    end;
    FreeAndNil(IncPerfil);
  end;

  procedure TZeos5UserControl.BtPerExcluiClick(Sender: TObject);
  var
    TempID : Integer;
    CanDelete : Boolean;
    ErrorMsg : String;
  begin
    if TCadPerfil(FormPerfilUsuarios).DSPerfilUser.RecordCount = 0 then Exit;
    TempID := TCadPerfil(FormPerfilUsuarios).DSPerfilUser.fieldByName('IDUser').asInteger;

    with UCGetSQLDataset('Select IdUser from '+ TableUsers +
                          ' Where tipo = ' + QuotedStr('U') + ' AND Perfil = ' + IntToStr(TempID)) do
    begin
      if FieldByName('IdUser').asInteger > 0 then
      begin
        Close;
        Free;
        if MessageDlg(Format(Settings.UsersProfile.PromptDelete, [TCadPerfil(FormPerfilUsuarios).DSPerfilUser.fieldByName('Nome').asString]), mtConfirmation, [mbYes,mbNo], 0)<> mrYes then exit;
      end else begin
        Close;
        Free;
      end;
    end;

    CanDelete := True;
    if Assigned(onDeleteProfile) then onDeleteProfile(Self, TempID, CanDelete, ErrorMsg);
    if Not CanDelete then begin
      MessageDlg(ErrorMSG, mtWarning, [mbOK], 0);
      Exit;
    end;

    UCExecSQL('Delete from '+ TableUsers + ' where IDUser = '+ IntToStr(TempID));
    UCExecSQL('Delete from '+ TableRights + ' where IDUser = '+ IntToStr(TempID));
    UCExecSQL('Update '+ TableUsers +' Set Perfil = null where IDUser = '+ IntToStr(TempID));
    TCadPerfil(FormPerfilUsuarios).DsPerfilUser.Close;
    TCadPerfil(FormPerfilUsuarios).DsPerfilUser.Open;
  end;

  procedure TZeos5UserControl.btIncPerGravarClick(Sender: TObject);
  var
    FNewIdUser : integer;
    FProfile : String;
  begin
    IncPerfil.btGravar.Enabled := False;
    if not IncPerfil.FAltera then
    begin // inclui perfil
      FNewIdUser := GetNewIdUser;
      FProfile := IncPerfil.EditDescricao.Text;
      if Assigned(onAddProfile) then onAddProfile(Self, FProfile);


      UCExecSQL('INSERT INTO ' + TableUsers +
                     ' ( IdUser, Nome, Tipo )  Values ( '+
                     IntToStr(FNewIdUser) + ', '+
                     QuotedStr(FProfile) + ', '+
                     QuotedStr('P')+ ')');
    end else begin // alterar perfil
      FNewIdUser := TCadPerfil(FormPerfilUsuarios).DSPerfilUser.FieldByName('IdUser').asInteger;
      FProfile := IncPerfil.EditDescricao.Text;


      UCExecSQL('UPDATE '+ TableUsers + ' SET '+
                     ' Nome = '+ QuotedStr(FProfile)+
                     ' Where IdUser = '+ IntToStr(FNewIdUser));
    end;


    TCadPerfil(FormPerfilUsuarios).DSPerfilUser.Close;
    TCadPerfil(FormPerfilUsuarios).DSPerfilUser.Open;
    TCadPerfil(FormPerfilUsuarios).DSPerfilUser.Locate('IDUser',FNewIdUser,[]);
    IncPerfil.Close;
  end;

  // Log do sistema
  procedure TZeos5UserControl.LogFormShow(Sender: TObject);
  var
    FTabUser, FTabLog : String;
  begin
    with TViewLog(FormLogControl) do
    begin
      with ZGetQuery do begin
        SQL.Text :='Select idUser, Nome from ' + TableUsers +
                          ' where tipo = '+ QuotedStr('U')+' order by nome';
        Open;
        ComboUsuario.Items.Append('Todos');
        ListIdUser.Append('0');
        while not eof do
        begin
          ComboUsuario.Items.Append(FieldByName('Nome').asString);
          ListIdUser.Append(FieldByName('idUser').asString);
          Next;
        end;
        Close;
        Free;
      end;
      ComboUsuario.ItemIndex := 0;

      FTabUser := TableUsers;
      FTabLog := LogControl.TableLog;

      TZDataset(DSLog).Sql.Text := 'Select '+ FTabUser+ '.Nome, '+FTabLog+'.* from '+FTabLog +
                                               ' Left outer join '+ FTabUser + ' on '+ FTabLog+'.idUser = '+FTabUser+'.idUser '+
                                               ' Where (data >=' + QuotedStr(FormatDateTime('yyyyMMddhhmmss',data1.DateTime)) + ') and (Data<='+ QuotedStr(FormatDateTime('yyyyMMddhhmmss',data2.DateTime)) +') order by data desc';
      DSLog.Open;
      DataSource1.Dataset := DSLog;
    end;
  end;

  procedure TZeos5UserControl.btexcluiClick(Sender: TObject);
  var
    FTabUser, FTabLog : String;
  begin
    with TViewLog(FormLogControl) do
    begin
      if MessageDlg(Const_LogC_ConfirmaExcluir, mtConfirmation, [mbYes,mbNo], 0) <> mrYes then exit;
      btFiltro.Enabled := False;
      FTabUser := TableUsers;
      FTabLog := LogControl.TableLog;

      With ZGetQuery do begin
        SQL.Text := 'Delete from '+FTabLog +
                    ' Where (data >=' + QuotedStr(FormatDateTime('yyyyMMddhhmmss',data1.DateTime)) + ') and (Data<='+ QuotedStr(FormatDateTime('yyyyMMddhhmmss',data2.DateTime)) +
                    ' ) and nivel <= ' + IntToStr(ComboNivel.ItemIndex);
        if ComboUsuario.ItemIndex > 0 then SQL.Text := SQL.Text + ' and '+FTabLog+'.idUser = ' + ListIdUser[ComboUsuario.ItemIndex];
        ExecSQL;
        Free;
      end;

      Log(Format('Efetuada exclusao de log do sistema : Usuario = %s | Data = %s a %s | Nivel <= %s',[comboUsuario.text, DateTimeToStr(Data1.datetime), DateTimeToStr(Data2.datetime), ComboNivel.text ]),2);
      DSLog.Close;
      DSLog.Open;
    end;
  end;

  procedure TZeos5UserControl.btfiltroClick(Sender: TObject);
  begin
    with TViewLog(FormLogControl) do
    begin
      btFiltro.Enabled := False;
      DSLog.Close;
      TZDataset(DSLog).SQL.Text := 'Select '+ TableUsers+ '.Nome, '+LogControl.TableLog+'.* from '+LogControl.TableLog +
                            ' Left outer join '+ TableUsers + ' on '+ LogControl.TableLog+'.idUser = '+TableUsers+'.idUser '+
                            ' Where (data >=' + QuotedStr(FormatDateTime('yyyyMMddhhmmss',data1.DateTime)) + ') and (Data<='+ QuotedStr(FormatDateTime('yyyyMMddhhmmss',data2.DateTime)) +
                            ' ) and nivel >= ' + IntToStr(ComboNivel.ItemIndex);
      if ComboUsuario.ItemIndex > 0 then TZDataset(DsLog).SQL.Text := TZDataset(DSLog).SQL.Text + ' and '+LogControl.TableLog+'.idUser = ' + ListIdUser[ComboUsuario.ItemIndex];
      TZDataset(DSLog).SQL.Text := TZDataset(DSLog).SQL.Text +' order by data desc';
      DSLog.Open;
    end;
  end;

end.
